package vn.viettuts.calculator;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.concurrent.TimeUnit;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.DesiredCapabilities;
import org.testng.Assert;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Test;

import io.appium.java_client.android.AndroidDriver;

public class CalculatorTest {
    AndroidDriver<?> driver;
    String fileName = "calculator.apk";
    File calculatorApp = new File("D:\\AppiumTest\\" + fileName);

    @BeforeTest
    public void beforeTest() throws MalformedURLException {
        DesiredCapabilities cap = new DesiredCapabilities();
        cap.setCapability("app", calculatorApp);
        // khai báo platform
        cap.setCapability("platformName", "ANDROID");
        // khai báo deviceName
        cap.setCapability("deviceName", "0.0.0.0:4723");
        // Tìm app và cài đặt app
        driver = new AndroidDriver(new URL("http://localhost:4723/wd/hub"), cap);
        driver.manage().timeouts().implicitlyWait(20, TimeUnit.SECONDS);
    }

    @Test
    public void addTest() {
        WebElement button_2 = 
                driver.findElementById("com.google.android.calculator:id/digit_2");
        WebElement button_9 = 
                driver.findElementById("com.google.android.calculator:id/digit_9");
        WebElement op_mul = 
                driver.findElementById("com.google.android.calculator:id/op_mul");
        WebElement button_equal = 
                driver.findElementById("com.google.android.calculator:id/eq");

        button_2.click();
        op_mul.click();
        button_9.click();
        button_equal.click();

        WebElement result = driver.findElementById("com.google.android.calculator:id/result");
        Assert.assertEquals(result.getText(), "18");
    }

    @Test
    public void mulTest() {
        WebElement button_1 = 
                driver.findElementById("com.google.android.calculator:id/digit_1");
        WebElement button_9 = 
                driver.findElementById("com.google.android.calculator:id/digit_9");
        WebElement op_add = 
                driver.findElementById("com.google.android.calculator:id/op_add");
        WebElement button_equal = 
                driver.findElementById("com.google.android.calculator:id/eq");

        button_1.click();
        op_add.click();
        button_9.click();
        button_equal.click();

        WebElement result = driver.findElementById("com.google.android.calculator:id/result");
        Assert.assertEquals(result.getText(), "10");
    }

    @AfterTest
    public void afterTest() {
        driver.quit();
    }
}
